Attribute VB_Name = "MQUTIL"
'
' MQUTIL - MQSeries Utility functions in Microsoft Visual Basic 5.0
'
' "vb50lib/mqutil5.bas" Global declarations and Code module
'
' Copyright 2001 IBM Global Services Australia
'
' Revision History
' ================
' Version   Date         Name        Changes
'       1   26 Jun 1998  Glenn       Initial version contains CcMsg and RcMsg
'                        Baddeley    functions for CMQB3C.BAS version 2
'                        <glenbadd@au1.ibm.com>  release 0.1 of SupportPac MA04.
'       2   21 Jan 1999  GB          Regenerate for new CMQB3C.BAS version 1
'                                    release 5, updated 18 Jan 1999.
'                                    Add MQU_ prefix to function names.
'                                    Add MQU_RcAdd feature.
'       3   24 Aug 1999  GB          Support for VB 5.0
'       4   6  Dec 2000  GB          Update for MQSeries 5.2 using
'                                    cmqc.h supplied for Windows NT,
'                                    Rename functions and tidy up code
'       5   2  Mar 2001  GB          Add 6100-6129 Reason Codes for MQSeries 5.2 C++
'
Option Explicit

Const NUMPFX = "("
Const DESCPFX = ")"

Dim MoreRc As String

Function MQCompCodeMsg(Cc As Long) As String

Dim Msg As String

  Select Case Cc
    Case 0: Msg = "OK"
    Case 1: Msg = "WARNING"
    Case 2: Msg = "FAILED"
    Case -1: Msg = "UNKNOWN"
    Case Else: Msg = Cc & "_UNDEFINED"
  End Select

  MQCompCodeMsg = "MQCC_" & Msg

End Function

Sub MQReasonCodeAdd(ByVal RcNum As Long, ByVal RcDesc As String)

    If RcNum Then
        MoreRc = MoreRc & NUMPFX & RcNum & DESCPFX & RcDesc  ' Add to list
    Else
        MoreRc = ""  ' Initialise if Rc 0
    End If
    
End Sub

Function MQReasonCodeMsg(Rc As Long) As String

Dim BegNumPos As Integer, BegDescPos As Integer, EndDescPos As Integer
Dim Msg As String

  Select Case Rc
    Case 0: Msg = "NONE"

    Case 2001: Msg = "ALIAS_BASE_Q_TYPE_ERROR"
    Case 2002: Msg = "ALREADY_CONNECTED"
    Case 2003: Msg = "BACKED_OUT"
    Case 2004: Msg = "BUFFER_ERROR"
    Case 2005: Msg = "BUFFER_LENGTH_ERROR"
    Case 2006: Msg = "CHAR_ATTR_LENGTH_ERROR"
    Case 2007: Msg = "CHAR_ATTRS_ERROR"
    Case 2008: Msg = "CHAR_ATTRS_TOO_SHORT"
    Case 2009: Msg = "CONNECTION_BROKEN"
    Case 2010: Msg = "DATA_LENGTH_ERROR"
    Case 2011: Msg = "DYNAMIC_Q_NAME_ERROR"
    Case 2012: Msg = "ENVIRONMENT_ERROR"
    Case 2013: Msg = "EXPIRY_ERROR"
    Case 2014: Msg = "FEEDBACK_ERROR"
    Case 2016: Msg = "GET_INHIBITED"
    Case 2017: Msg = "HANDLE_NOT_AVAILABLE"
    Case 2018: Msg = "HCONN_ERROR"
    Case 2019: Msg = "HOBJ_ERROR"
    Case 2020: Msg = "INHIBIT_VALUE_ERROR"
    Case 2021: Msg = "INT_ATTR_COUNT_ERROR"
    Case 2022: Msg = "INT_ATTR_COUNT_TOO_SMALL"
    Case 2023: Msg = "INT_ATTRS_ARRAY_ERROR"
    Case 2024: Msg = "SYNCPOINT_LIMIT_REACHED"
    Case 2025: Msg = "MAX_CONNS_LIMIT_REACHED"
    Case 2026: Msg = "MD_ERROR"
    Case 2027: Msg = "MISSING_REPLY_TO_Q"
    Case 2029: Msg = "MSG_TYPE_ERROR"
    Case 2030: Msg = "MSG_TOO_BIG_FOR_Q"
    Case 2031: Msg = "MSG_TOO_BIG_FOR_Q_MGR"
    Case 2033: Msg = "NO_MSG_AVAILABLE"
    Case 2034: Msg = "NO_MSG_UNDER_CURSOR"
    Case 2035: Msg = "NOT_AUTHORIZED"
    Case 2036: Msg = "NOT_OPEN_FOR_BROWSE"
    Case 2037: Msg = "NOT_OPEN_FOR_INPUT"
    Case 2038: Msg = "NOT_OPEN_FOR_INQUIRE"
    Case 2039: Msg = "NOT_OPEN_FOR_OUTPUT"
    Case 2040: Msg = "NOT_OPEN_FOR_SET"
    Case 2041: Msg = "OBJECT_CHANGED"
    Case 2042: Msg = "OBJECT_IN_USE"
    Case 2043: Msg = "OBJECT_TYPE_ERROR"
    Case 2044: Msg = "OD_ERROR"
    Case 2045: Msg = "OPTION_NOT_VALID_FOR_TYPE"
    Case 2046: Msg = "OPTIONS_ERROR"
    Case 2047: Msg = "PERSISTENCE_ERROR"
    Case 2048: Msg = "PERSISTENT_NOT_ALLOWED"
    Case 2049: Msg = "PRIORITY_EXCEEDS_MAXIMUM"
    Case 2050: Msg = "PRIORITY_ERROR"
    Case 2051: Msg = "PUT_INHIBITED"
    Case 2052: Msg = "Q_DELETED"
    Case 2053: Msg = "Q_FULL"
    Case 2055: Msg = "Q_NOT_EMPTY"
    Case 2056: Msg = "Q_SPACE_NOT_AVAILABLE"
    Case 2057: Msg = "Q_TYPE_ERROR"
    Case 2058: Msg = "Q_MGR_NAME_ERROR"
    Case 2059: Msg = "Q_MGR_NOT_AVAILABLE"
    Case 2061: Msg = "REPORT_OPTIONS_ERROR"
    Case 2062: Msg = "SECOND_MARK_NOT_ALLOWED"
    Case 2063: Msg = "SECURITY_ERROR"
    Case 2065: Msg = "SELECTOR_COUNT_ERROR"
    Case 2066: Msg = "SELECTOR_LIMIT_EXCEEDED"
    Case 2067: Msg = "SELECTOR_ERROR"
    Case 2068: Msg = "SELECTOR_NOT_FOR_TYPE"
    Case 2069: Msg = "SIGNAL_OUTSTANDING"
    Case 2070: Msg = "SIGNAL_REQUEST_ACCEPTED"
    Case 2071: Msg = "STORAGE_NOT_AVAILABLE"
    Case 2072: Msg = "SYNCPOINT_NOT_AVAILABLE"
    Case 2075: Msg = "TRIGGER_CONTROL_ERROR"
    Case 2076: Msg = "TRIGGER_DEPTH_ERROR"
    Case 2077: Msg = "TRIGGER_MSG_PRIORITY_ERR"
    Case 2078: Msg = "TRIGGER_TYPE_ERROR"
    Case 2079: Msg = "TRUNCATED_MSG_ACCEPTED"
    Case 2080: Msg = "TRUNCATED_MSG_FAILED"
    Case 2082: Msg = "UNKNOWN_ALIAS_BASE_Q"
    Case 2085: Msg = "UNKNOWN_OBJECT_NAME"
    Case 2086: Msg = "UNKNOWN_OBJECT_Q_MGR"
    Case 2087: Msg = "UNKNOWN_REMOTE_Q_MGR"
    Case 2090: Msg = "WAIT_INTERVAL_ERROR"
    Case 2091: Msg = "XMIT_Q_TYPE_ERROR"
    Case 2092: Msg = "XMIT_Q_USAGE_ERROR"
    Case 2093: Msg = "NOT_OPEN_FOR_PASS_ALL"
    Case 2094: Msg = "NOT_OPEN_FOR_PASS_IDENT"
    Case 2095: Msg = "NOT_OPEN_FOR_SET_ALL"
    Case 2096: Msg = "NOT_OPEN_FOR_SET_IDENT"
    Case 2097: Msg = "CONTEXT_HANDLE_ERROR"
    Case 2098: Msg = "CONTEXT_NOT_AVAILABLE"
    Case 2099: Msg = "SIGNAL1_ERROR"
    Case 2100: Msg = "OBJECT_ALREADY_EXISTS"
    Case 2101: Msg = "OBJECT_DAMAGED"
    Case 2102: Msg = "RESOURCE_PROBLEM"
    Case 2103: Msg = "ANOTHER_Q_MGR_CONNECTED"
    Case 2104: Msg = "UNKNOWN_REPORT_OPTION"
    Case 2105: Msg = "STORAGE_CLASS_ERROR"
    Case 2106: Msg = "COD_NOT_VALID_FOR_XCF_Q"
    Case 2107: Msg = "XWAIT_CANCELED"
    Case 2108: Msg = "XWAIT_ERROR"
    Case 2109: Msg = "SUPPRESSED_BY_EXIT"
    Case 2110: Msg = "FORMAT_ERROR"
    Case 2111: Msg = "SOURCE_CCSID_ERROR"
    Case 2112: Msg = "SOURCE_INTEGER_ENC_ERROR"
    Case 2113: Msg = "SOURCE_DECIMAL_ENC_ERROR"
    Case 2114: Msg = "SOURCE_FLOAT_ENC_ERROR"
    Case 2115: Msg = "TARGET_CCSID_ERROR"
    Case 2116: Msg = "TARGET_INTEGER_ENC_ERROR"
    Case 2117: Msg = "TARGET_DECIMAL_ENC_ERROR"
    Case 2118: Msg = "TARGET_FLOAT_ENC_ERROR"
    Case 2119: Msg = "NOT_CONVERTED"
    Case 2120: Msg = "CONVERTED_MSG_TOO_BIG"
    Case 2120: Msg = "TRUNCATED"
    Case 2121: Msg = "NO_EXTERNAL_PARTICIPANTS"
    Case 2122: Msg = "PARTICIPANT_NOT_AVAILABLE"
    Case 2123: Msg = "OUTCOME_MIXED"
    Case 2124: Msg = "OUTCOME_PENDING"
    Case 2125: Msg = "BRIDGE_STARTED"
    Case 2126: Msg = "BRIDGE_STOPPED"
    Case 2127: Msg = "ADAPTER_STORAGE_SHORTAGE"
    Case 2128: Msg = "UOW_IN_PROGRESS"
    Case 2129: Msg = "ADAPTER_CONN_LOAD_ERROR"
    Case 2130: Msg = "ADAPTER_SERV_LOAD_ERROR"
    Case 2131: Msg = "ADAPTER_DEFS_ERROR"
    Case 2132: Msg = "ADAPTER_DEFS_LOAD_ERROR"
    Case 2133: Msg = "ADAPTER_CONV_LOAD_ERROR"
    Case 2134: Msg = "BO_ERROR"
    Case 2135: Msg = "DH_ERROR"
    Case 2136: Msg = "MULTIPLE_REASONS"
    Case 2137: Msg = "OPEN_FAILED"
    Case 2138: Msg = "ADAPTER_DISC_LOAD_ERROR"
    Case 2139: Msg = "CNO_ERROR"
    Case 2140: Msg = "CICS_WAIT_FAILED"
    Case 2141: Msg = "DLH_ERROR"
    Case 2142: Msg = "HEADER_ERROR"
    Case 2143: Msg = "SOURCE_LENGTH_ERROR"
    Case 2144: Msg = "TARGET_LENGTH_ERROR"
    Case 2145: Msg = "SOURCE_BUFFER_ERROR"
    Case 2146: Msg = "TARGET_BUFFER_ERROR"
    Case 2148: Msg = "IIH_ERROR"
    Case 2149: Msg = "PCF_ERROR"
    Case 2150: Msg = "DBCS_ERROR"
    Case 2152: Msg = "OBJECT_NAME_ERROR"
    Case 2153: Msg = "OBJECT_Q_MGR_NAME_ERROR"
    Case 2154: Msg = "RECS_PRESENT_ERROR"
    Case 2155: Msg = "OBJECT_RECORDS_ERROR"
    Case 2156: Msg = "RESPONSE_RECORDS_ERROR"
    Case 2157: Msg = "ASID_MISMATCH"
    Case 2158: Msg = "PMO_RECORD_FLAGS_ERROR"
    Case 2159: Msg = "PUT_MSG_RECORDS_ERROR"
    Case 2160: Msg = "CONN_ID_IN_USE"
    Case 2161: Msg = "Q_MGR_QUIESCING"
    Case 2162: Msg = "Q_MGR_STOPPING"
    Case 2163: Msg = "DUPLICATE_RECOV_COORD"
    Case 2173: Msg = "PMO_ERROR"
    Case 2182: Msg = "API_EXIT_NOT_FOUND"
    Case 2183: Msg = "API_EXIT_LOAD_ERROR"
    Case 2184: Msg = "REMOTE_Q_NAME_ERROR"
    Case 2185: Msg = "INCONSISTENT_PERSISTENCE"
    Case 2186: Msg = "GMO_ERROR"
    Case 2191: Msg = "TMC_ERROR"
    Case 2192: Msg = "STORAGE_MEDIUM_FULL"  ' Also PAGESET_FULL on OS/390
    Case 2193: Msg = "PAGESET_ERROR"
    Case 2194: Msg = "NAME_NOT_VALID_FOR_TYPE"
    Case 2195: Msg = "UNEXPECTED_ERROR"
    Case 2196: Msg = "UNKNOWN_XMIT_Q"
    Case 2197: Msg = "UNKNOWN_DEF_XMIT_Q"
    Case 2198: Msg = "DEF_XMIT_Q_TYPE_ERROR"
    Case 2199: Msg = "DEF_XMIT_Q_USAGE_ERROR"
    Case 2201: Msg = "NAME_IN_USE"
    Case 2202: Msg = "CONNECTION_QUIESCING"
    Case 2203: Msg = "CONNECTION_STOPPING"
    Case 2204: Msg = "ADAPTER_NOT_AVAILABLE"
    Case 2206: Msg = "MSG_ID_ERROR"
    Case 2207: Msg = "CORREL_ID_ERROR"
    Case 2208: Msg = "FILE_SYSTEM_ERROR"
    Case 2209: Msg = "NO_MSG_LOCKED"
    Case 2216: Msg = "FILE_NOT_AUDITED"
    Case 2217: Msg = "CONNECTION_NOT_AUTHORIZED"
    Case 2218: Msg = "MSG_TOO_BIG_FOR_CHANNEL"
    Case 2219: Msg = "CALL_IN_PROGRESS"
    Case 2220: Msg = "RMH_ERROR"
    Case 2222: Msg = "Q_MGR_ACTIVE"
    Case 2223: Msg = "Q_MGR_NOT_ACTIVE"
    Case 2224: Msg = "Q_DEPTH_HIGH"
    Case 2225: Msg = "Q_DEPTH_LOW"
    Case 2226: Msg = "Q_SERVICE_INTERVAL_HIGH"
    Case 2227: Msg = "Q_SERVICE_INTERVAL_OK"
    Case 2233: Msg = "CHANNEL_AUTO_DEF_OK"
    Case 2234: Msg = "CHANNEL_AUTO_DEF_ERROR"
    Case 2235: Msg = "CFH_ERROR"
    Case 2236: Msg = "CFIL_ERROR"
    Case 2237: Msg = "CFIN_ERROR"
    Case 2238: Msg = "CFSL_ERROR"
    Case 2239: Msg = "CFST_ERROR"
    Case 2241: Msg = "INCOMPLETE_GROUP"
    Case 2242: Msg = "INCOMPLETE_MESSAGE"
    Case 2243: Msg = "INCONSISTENT_CCSIDS"
    Case 2244: Msg = "INCONSISTENT_ENCODING"
    Case 2245: Msg = "INCONSISTENT_UOW"
    Case 2246: Msg = "INVALID_MSG_UNDER_CURSOR"
    Case 2247: Msg = "MATCH_OPTIONS_ERROR"
    Case 2248: Msg = "MDE_ERROR"
    Case 2249: Msg = "MSG_FLAGS_ERROR"
    Case 2250: Msg = "MSG_SEQ_NUMBER_ERROR"
    Case 2251: Msg = "OFFSET_ERROR"
    Case 2252: Msg = "ORIGINAL_LENGTH_ERROR"
    Case 2253: Msg = "SEGMENT_LENGTH_ZERO"
    Case 2255: Msg = "UOW_NOT_AVAILABLE"
    Case 2256: Msg = "WRONG_GMO_VERSION"
    Case 2257: Msg = "WRONG_MD_VERSION"
    Case 2258: Msg = "GROUP_ID_ERROR"
    Case 2259: Msg = "INCONSISTENT_BROWSE"
    Case 2260: Msg = "XQH_ERROR"
    Case 2261: Msg = "SRC_ENV_ERROR"
    Case 2262: Msg = "SRC_NAME_ERROR"
    Case 2263: Msg = "DEST_ENV_ERROR"
    Case 2264: Msg = "DEST_NAME_ERROR"
    Case 2265: Msg = "TM_ERROR"
    Case 2280: Msg = "HCONFIG_ERROR"
    Case 2281: Msg = "FUNCTION_ERROR"
    Case 2282: Msg = "CHANNEL_STARTED"
    Case 2283: Msg = "CHANNEL_STOPPED"
    Case 2284: Msg = "CHANNEL_CONV_ERROR"
    Case 2285: Msg = "SERVICE_NOT_AVAILABLE"
    Case 2286: Msg = "INITIALIZATION_FAILED"
    Case 2287: Msg = "TERMINATION_FAILED"
    Case 2288: Msg = "UNKNOWN_Q_NAME"
    Case 2289: Msg = "SERVICE_ERROR"
    Case 2290: Msg = "Q_ALREADY_EXISTS"
    Case 2291: Msg = "USER_ID_NOT_AVAILABLE"
    Case 2292: Msg = "UNKNOWN_ENTITY"
    Case 2293: Msg = "UNKNOWN_AUTH_ENTITY"
    Case 2294: Msg = "UNKNOWN_REF_OBJECT"
    Case 2295: Msg = "CHANNEL_ACTIVATED"
    Case 2296: Msg = "CHANNEL_NOT_ACTIVATED"  ' Last in MQ 2.2
    Case 2297: Msg = "UOW_CANCELED"
    Case 2298: Msg = "FUNCTION_NOT_SUPPORTED"
    Case 2299: Msg = "SELECTOR_TYPE_ERROR"
    Case 2300: Msg = "COMMAND_TYPE_ERROR"
    Case 2301: Msg = "MULTIPLE_INSTANCE_ERROR"
    Case 2302: Msg = "SYSTEM_ITEM_NOT_ALTERABLE"
    Case 2303: Msg = "BAG_CONVERSION_ERROR"
    Case 2304: Msg = "SELECTOR_OUT_OF_RANGE"
    Case 2305: Msg = "SELECTOR_NOT_UNIQUE"
    Case 2306: Msg = "INDEX_NOT_PRESENT"
    Case 2307: Msg = "STRING_ERROR"
    Case 2308: Msg = "ENCODING_NOT_SUPPORTED"
    Case 2309: Msg = "SELECTOR_NOT_PRESENT"
    Case 2310: Msg = "OUT_SELECTOR_ERROR"
    Case 2311: Msg = "STRING_TRUNCATED"
    Case 2312: Msg = "SELECTOR_WRONG_TYPE"
    Case 2313: Msg = "INCONSISTENT_ITEM_TYPE"
    Case 2314: Msg = "INDEX_ERROR"
    Case 2315: Msg = "SYSTEM_BAG_NOT_ALTERABLE"
    Case 2316: Msg = "ITEM_COUNT_ERROR"
    Case 2317: Msg = "FORMAT_NOT_SUPPORTED"
    Case 2318: Msg = "SELECTOR_NOT_SUPPORTED"
    Case 2319: Msg = "ITEM_VALUE_ERROR"
    Case 2320: Msg = "HBAG_ERROR"
    Case 2321: Msg = "PARAMETER_MISSING"
    Case 2322: Msg = "CMD_SERVER_NOT_AVAILABLE"
    Case 2323: Msg = "STRING_LENGTH_ERROR"
    Case 2324: Msg = "INQUIRY_COMMAND_ERROR"
    Case 2325: Msg = "NESTED_BAG_NOT_SUPPORTED"
    Case 2326: Msg = "BAG_WRONG_TYPE"
    Case 2327: Msg = "ITEM_TYPE_ERROR"
    Case 2328: Msg = "SYSTEM_BAG_NOT_DELETABLE"
    Case 2329: Msg = "SYSTEM_ITEM_NOT_DELETABLE"
    Case 2330: Msg = "CODED_CHAR_SET_ID_ERROR"
    Case 2331: Msg = "MSG_TOKEN_ERROR"
    Case 2332: Msg = "MISSING_WIH"
    Case 2333: Msg = "WIH_ERROR"
    Case 2334: Msg = "RFH_ERROR"
    Case 2335: Msg = "RFH_STRING_ERROR"  ' Last in MQ 5.0
    Case 2336: Msg = "RFH_COMMAND_ERROR"
    Case 2337: Msg = "RFH_PARM_ERROR"
    Case 2338: Msg = "RFH_DUPLICATE_PARM"
    Case 2339: Msg = "RFH_PARM_MISSING"  ' Last in MQ 5.1
    Case 2340: Msg = "CHAR_CONVERSION_ERROR"
    Case 2341: Msg = "UCS2_CONVERSION_ERROR"
    Case 2342: Msg = "DB2_NOT_AVAILABLE"
    Case 2343: Msg = "OBJECT_NOT_UNIQUE"
    Case 2344: Msg = "CONN_TAG_NOT_RELEASED"
    Case 2345: Msg = "CF_NOT_AVAILABLE"
    Case 2346: Msg = "CF_STRUC_IN_USE"
    Case 2347: Msg = "CF_STRUC_LIST_HDR_IN_USE"
    Case 2348: Msg = "CF_STRUC_AUTH_FAILED"
    Case 2349: Msg = "CF_STRUC_ERROR"
    Case 2350: Msg = "CONN_TAG_NOT_USABLE"
    Case 2351: Msg = "GLOBAL_UOW_CONFLICT"
    Case 2352: Msg = "LOCAL_UOW_CONFLICT"
    Case 2353: Msg = "HANDLE_IN_USE_FOR_UOW"
    Case 2354: Msg = "UOW_ENLISTMENT_ERROR"
    Case 2355: Msg = "UOW_MIX_NOT_SUPPORTED"
    Case 2356: Msg = "WXP_ERROR"
    Case 2357: Msg = "CURRENT_RECORD_ERROR"
    Case 2358: Msg = "NEXT_OFFSET_ERROR"
    Case 2359: Msg = "NO_RECORD_AVAILABLE"
    Case 2360: Msg = "OBJECT_LEVEL_INCOMPATIBLE"
    Case 2361: Msg = "NEXT_RECORD_ERROR"  ' Last in MQ 5.2

    Case 6100: Msg = "REOPEN_EXCL_INPUT_ERROR"
    Case 6101: Msg = "REOPEN_INQUIRE_ERROR"
    Case 6102: Msg = "REOPEN_SAVED_CONTEXT_ERR"
    Case 6103: Msg = "REOPEN_TEMPORARY_Q_ERROR"
    Case 6104: Msg = "ATTRIBUTE_LOCKED"
    Case 6105: Msg = "CURSOR_NOT_VALID"
    Case 6106: Msg = "ENCODING_ERROR"
    Case 6107: Msg = "STRUC_ID_ERROR"
    Case 6108: Msg = "NULL_POINTER"
    Case 6109: Msg = "NO_CONNECTION_REFERENCE"
    Case 6110: Msg = "NO_BUFFER"
    Case 6111: Msg = "BINARY_DATA_LENGTH_ERROR"
    Case 6112: Msg = "BUFFER_NOT_AUTOMATIC"
    Case 6113: Msg = "INSUFFICIENT_BUFFER"
    Case 6114: Msg = "INSUFFICIENT_DATA"
    Case 6115: Msg = "DATA_TRUNCATED"
    Case 6116: Msg = "ZERO_LENGTH"
    Case 6117: Msg = "NEGATIVE_LENGTH"
    Case 6118: Msg = "NEGATIVE_OFFSET"
    Case 6119: Msg = "INCONSISTENT_FORMAT"
    Case 6120: Msg = "INCONSISTENT_OBJECT_STATE"
    Case 6121: Msg = "CONTEXT_OBJECT_NOT_VALID"
    Case 6122: Msg = "CONTEXT_OPEN_ERROR"
    Case 6123: Msg = "STRUC_LENGTH_ERROR"
    Case 6124: Msg = "NOT_CONNECTED"
    Case 6125: Msg = "NOT_OPEN"
    Case 6126: Msg = "DISTRIBUTION_LIST_EMPTY"
    Case 6127: Msg = "INCONSISTENT_OPEN_OPTIONS"
    Case 6128: Msg = "WRONG_VERSION"
    Case 6129: Msg = "REFERENCE_ERROR"  ' Last in MQ 5.2

    Case Else
      BegNumPos = InStr(MoreRc, NUMPFX & Rc & DESCPFX)
      If BegNumPos Then
        BegDescPos = InStr(BegNumPos + 1, MoreRc, DESCPFX) + 1
        EndDescPos = InStr(BegDescPos + 1, MoreRc, NUMPFX)
        If EndDescPos = 0 Then EndDescPos = Len(MoreRc) + 1
        Msg = Mid(MoreRc, BegDescPos, EndDescPos - BegDescPos)
      Else
        Msg = Rc & "_UNDEFINED"
      End If
  End Select

  MQReasonCodeMsg = "MQRC_" & Msg

End Function

